NAME
	bbcbas - run ROM BBC Basic

SYNOPSIS
	bbcbas [-h] [basic_file]

DESCRIPTION
	Run the NC's ROM BBC Basic as if it were a ZCN program.
	Auto-runs `basic_file' if specified.

	This man page merely covers differences from running it
	natively under the ROM software - actually documenting BBC
	Basic would make it pretty huge. :-)

OPTIONS
	-h	give usage help (synopsis).

DIFFERENCES
	The most significant differences:

	- runs about 10% faster
	- supports BBC-style `copy' cursor, except on NC200, which
	  makes editing much easier (see below)
	- supports writing CP/M-style text files (see below)
	- supports larger files (up to 253k)
	- can auto-run any basic file
	- builtin help of sorts (do *KEY to get index)
	- OPENUP is not fully supported (it acts like OPENIN)
	- the "COM:" file is not supported
	- text windows are not supported
	- maximum of three files open at once
	- keyboard `typeahead' is limited
	- *DELETE works for wildcards
	- the only way to exit is *BYE or *QUIT

TEXT FILES
	Anywhere in BBC Basic you can read/write a text file if you
	prefix the name with a colon (`:'). Due to the way ZCN and
	CP/M store inexact file lengths (in multiples of 128 bytes
	only), you should always read/write text files like this to
	avoid problems.

THE COPY CURSOR
	You can copy text from anywhere on the screen by using the
	cursor keys (or ^E/^S/^D/^X) to move a second cursor, and
	pressing Tab to copy the character it's currently on.

BUGS
	Using it via the serial port can be problematic, especially on
	the NC200.

	PTR#/EXT# give incorrect results for text files.

	On the NC200, there is no copy cursor and the "drive lights"
	area simply remains as ZCN left it.

	If ZCN output is redirected to the parallel port, non-ASCII
	characters are only sent to the printer, not displayed.

SEE ALSO
	bbcmin, runrom
